      module declare

      implicit none

      INTEGER, PARAMETER, PRIVATE  :: dp = SELECTED_REAL_KIND(12, 60)

      !integer, parameter :: ntime=1+3*24*3600/60/10   !Nb GECKO time
      !integer, parameter :: ntime=1+5*24*3600/60/10   !Nb GECKO time
      integer, parameter :: ntime=1+5*24*3600/300   !Nb GECKO time
      !integer, parameter :: ntime=1+9*24*3600/360/10   !Nb GECKO time
      integer, parameter :: nspec=6        !Nb of VBS species
      integer, parameter :: nparam=7       !Nb of coefs to fit

      real*8 :: kp                       !Reaction rate for precursor
      real*8 :: chisq,deltat

      real*8, dimension(nspec) :: k      !Reaction rate for VBS species
!     real*8, dimension(nspec,nparam):: alpha  !Coefs to be fitted
      real*8, dimension(ntime) :: time   !GECKO time array in sec
      real*8, dimension(nspec,ntime)   :: ygecko   !GECKO concentrations as read
      real*8, dimension(nspec,ntime)   :: wmol
      real*8, dimension(nspec)         :: avgwmol
      real*8, dimension(ntime)         :: precursor!GECKO concentrations

      real*8, dimension(nspec,ntime-1)   :: kygecko
      real*8, dimension(ntime-1)   :: kprecursor
      real*8, dimension(nspec,ntime-1) :: dygecko  !Derivatives
      real*8, dimension(nspec,ntime-1) :: avggecko !Average conc over dt
      real*8, dimension(ntime-1)       :: avgprecursor !Average conc over dt
      real*8, dimension(ntime-1)       :: xind,sigm
      real*8, dimension(nparam)   :: w
      real*8, dimension(nparam,nparam)   :: v
      real*8, dimension(ntime-1,nparam)   :: u

      integer :: keybvls
      real (dp) :: abvlsx(ntime-1,nparam)
      real (dp) :: abvls(ntime-1,nparam)
      real (dp) :: bbvls(ntime-1)
      real (dp) :: alpha(nparam)
      real (dp) :: alphal(nparam)
      real (dp) :: alphau(nparam)
      real (dp) :: beta(nparam)
      real (dp) :: betal(nparam)
      real (dp) :: betau(nparam)
      integer, dimension(nparam+1) :: istatebvls
      integer :: loopabvls

      end module declare

