      module coeffs
!
      use nrtype
!
      implicit none
!
! Number of time steps for which GECKO output is available
      !integer(I4B), parameter :: ntime=3*24*6
      !integer(I4B), parameter :: ntime=5*24*6
      integer(I4B), parameter :: ntime=5*24*12
      !integer(I4B), parameter :: ntime=9*24 

! precursor initial concentrations
      real(SP),parameter :: conc_prec=2.5e7 !initial value 1ppt
      !real(SP),parameter :: conc_prec=2.5e10 !initial value 1ppb
      !real(SP),parameter :: conc_prec=25 !initial value

! Number of VBS species
      integer(I4B), parameter :: nspec=4
!
! Reaction rate constants for VBS species
      real(SP), dimension(nspec) :: k
!
! Reaction rate constant for precursor
      real(SP) :: kp
!
! Parameters to be fitted
      real(SP), dimension(nspec) :: a
      real(SP), dimension(nspec,nspec) :: b
!
      end module coeffs
